program RS_485_QC_PROPGRAM;

uses
  crt;

const

  port1 = $3f8;
  port2 = $2f8;

var
  delaytime : integer;

procedure init(p,n : integer);
begin
  port[p+3] := $80;
  port[p  ] := Lo(n);
  port[p+1] := Hi(n);
  port[p+3] := 3;
end;

procedure test;
const
  baud1 : array[1..3] of integer = (  96,  12,    2);
  baud2 : array[1..3] of    word = (1200,9600,57600);
var
  p1,p2,tx,rx,dir,stat,testloop,baudindex,i : integer;
  b1,b2 : byte;
  c : char;
begin
  for testloop := 1 to 2 do
  begin
    clrscr;
    if testloop = 1 then
      writeln('Please Select "Enable by RTS".')
    else
      writeln('Please Select "Enable by bit 0 of reg"');
    c := readkey;
    for baudindex := 1 to 3 do
      for dir := 1 to 2 do
        for tx := 1 to 2 do
          for rx := 1 to 2 do
          begin
            clrscr;
            if dir = 1 then write('Port 1 ---> Port 2 ')
                       else write('Port 2 ---> Port 1 ');
            write('TX : ');
            if tx = 1 then write('enable  ')
                      else write('<DISABLE>  ');
            write('RX : ');
            if rx = 1 then write('enable  ')
                      else write('<DISABLE>  ');
            writeln('Baud : ',baud2[baudindex]:5);

            if dir = 1 then
            begin
              p1 := port1;
              p2 := port2;
            end
            else
            begin
              p1 := port2;
              p2 := port1;
            end;

            init(p1,baud1[baudindex]);
            init(p2,baud1[baudindex]);

            if tx = 1 then
            begin
              if testloop = 1 then port[p1+4] := 3  { /RTS = Low   }
                              else port[p1+7] := 1; { bit 0 enable }
            end
            else
            begin
              if testloop = 1 then port[p1+4] := 0  { /RTS = Low   }
                              else port[p1+7] := 0; { bit 0 enable }
            end;

            if rx = 1 then port[p2+7] := 2          { Enable RX    }
                      else port[p2+7] := 0;         { Disable RX   }
            stat := 0;
            for i := 1 to 20 do
            begin
              repeat
                b1 := random(256);
              until b1 <> b2;
              port[p1] := b1;
              delay(delaytime);
              b2 := port[p2];
              if (b1 <> b2) xor ((tx=2) or (rx=2)) then stat := 1;
              writeln(b1:4,b2:12);
            end;
            if stat <> 0 then
            begin
              writeln;
              sound(880);
              writeln('Test Error !    Hit a key to continue....');
              delay(500);
              nosound;
              while keypressed do c := readkey;
              c := readkey;
            end;
          end;
  end;
end;

begin { main }
  clrscr;
  writeln('RS-485 SELFTEST PROGRAM V1.0');
  writeln('Port #1 address : 3F8h');
  writeln('Port #2 address : 2F8h');
  writeln;
  writeln;
  randomize;
  delaytime := 100;
  write('Enter delay time (1..1000) (ms) : ');
  readln(delaytime);
  test;
  writeln('Done.......');
end.
