/* Decision Computer International lmt.
   PCI device header for 8 Port PCCOM Card
   Copyright 1999
*/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <alloc.h>

char bno,dno;

int PCIinit();
int PCIaddress();
char PCIirq();

int PCIinit() /*Get initial data of PCI*/
{
asm {
 mov ah,0xb1;
 mov al,2
 mov cx,0x0002
 mov dx,0x6666
 mov si,0
 int 0x1a
 cmp ah,0
 jnz error1
 mov bno,bh
 mov dno,bl
}
return 0;

error1:
return -1;
}


int PCIaddress() /*Get new address reported by BIOS*/
{
int address;

asm{
 mov ah,0xb1;
 mov al,0x09;
 mov di,0x1c;
 mov bh,bno
 mov bl,dno
 int 0x1a
 cmp ah,0
 jnz error2
 mov address,cx
 sub address,1
}
return address;

error2:
return -1;
}

char PCIirq() /*Get new IRQ generated by BIOS*/
{
char irq;

asm{
 mov ah,0xb1
 mov al,0x08
 mov di,0x3c
 mov bh,bno
 mov bl,dno
 int 0x1a
 cmp ah,0
 jnz error3
 mov irq,cl
}
return irq;

error3:
return -1;
}
